import uuid

from decimal import Decimal

from brewman.schemas import to_camel
from pydantic import BaseModel, ConfigDict, Field


class Incentive(BaseModel):
    employee_id: uuid.UUID
    name: str
    designation: str
    department: str
    days_worked: Decimal = Field(ge=0)
    points: Decimal = Field(ge=0)
    model_config = ConfigDict(alias_generator=to_camel, populate_by_name=True)
