import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { Attendance } from './attendance';
import { AttendanceService } from './attendance.service';

@Injectable({
  providedIn: 'root',
})
export class AttendanceResolver {
  constructor(private ser: AttendanceService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Attendance> {
    const date = route.paramMap.get('date');
    return this.ser.get(date);
  }
}
