import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';

import { BatchIntegrity } from './batch-integrity';
import { BatchIntegrityReportDatasource } from './batch-integrity-report-datasource';

@Component({
  selector: 'app-batch-integrity',
  templateUrl: './batch-integrity-report.component.html',
  styleUrls: ['./batch-integrity-report.component.css'],
})
export class BatchIntegrityReportComponent implements OnInit {
  info: BatchIntegrity[] = [];
  dataSource: BatchIntegrityReportDatasource = new BatchIntegrityReportDatasource(this.info);
  displayedColumns = ['batch', 'details'];

  constructor(
    private route: ActivatedRoute,
    private router: Router,
  ) {}

  ngOnInit() {
    this.route.data.subscribe((value) => {
      const data = value as { info: BatchIntegrity[] };
      this.info = data.info;
      this.dataSource = new BatchIntegrityReportDatasource(this.info);
    });
  }

  refresh() {
    this.router.navigate([]);
  }
}
