import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { CashFlowResolver } from './cash-flow-resolver.service';
import { CashFlowComponent } from './cash-flow.component';

const cashFlowRoutes: Routes = [
  {
    path: '',
    component: CashFlowComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Cash Flow',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(CashFlowResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':id',
    component: CashFlowComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Cash Flow',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(CashFlowResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(cashFlowRoutes)],
  exports: [RouterModule],
  providers: [CashFlowResolver],
})
export class CashFlowRoutingModule {}
