import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { Daybook } from './daybook';
import { DaybookService } from './daybook.service';

@Injectable({
  providedIn: 'root',
})
export class DaybookResolver {
  constructor(private ser: DaybookService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Daybook> {
    const startDate = route.queryParamMap.get('startDate') || null;
    const finishDate = route.queryParamMap.get('finishDate') || null;
    return this.ser.list(startDate, finishDate);
  }
}
