import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { Employee } from './employee';
import { EmployeeService } from './employee.service';

@Injectable({
  providedIn: 'root',
})
export class EmployeeResolver {
  constructor(private ser: EmployeeService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Employee> {
    const id = route.paramMap.get('id');
    return this.ser.get(id);
  }
}
