import { CostCentre } from '../core/cost-centre';

export class Employee {
  id: string | undefined;
  code: number;
  name: string;
  isStarred: boolean;
  isActive: boolean;
  designation: string;
  salary: number;
  points: number;
  joiningDate: string;
  leavingDate: string | null;
  costCentre: CostCentre;

  public constructor(init?: Partial<Employee>) {
    this.code = 0;
    this.name = '';
    this.isStarred = false;
    this.isActive = true;
    this.designation = '';
    this.salary = 0;
    this.points = 0;
    this.joiningDate = '';
    this.leavingDate = null;
    this.costCentre = new CostCentre();
    Object.assign(this, init);
  }
}
