import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { LedgerResolver } from './ledger-resolver.service';
import { LedgerComponent } from './ledger.component';

const ledgerRoutes: Routes = [
  {
    path: '',
    component: LedgerComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Ledger',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(LedgerResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':id',
    component: LedgerComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Ledger',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(LedgerResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(ledgerRoutes)],
  exports: [RouterModule],
  providers: [LedgerResolver],
})
export class LedgerRoutingModule {}
