import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { NetTransactionsResolver } from './net-transactions-resolver.service';
import { NetTransactionsComponent } from './net-transactions.component';

const netTransactionsRoutes: Routes = [
  {
    path: '',
    component: NetTransactionsComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Net Transactions',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(NetTransactionsResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(netTransactionsRoutes)],
  exports: [RouterModule],
  providers: [NetTransactionsResolver],
})
export class NetTransactionsRoutingModule {}
