import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/internal/Observable';
import { catchError } from 'rxjs/operators';

import { ErrorLoggerService } from '../core/error-logger.service';

import { NonContractPurchase } from './non-contract-purchase';

const url = '/api/non-contract-purchase';
const serviceName = 'NonContractPurchaseService';

@Injectable({
  providedIn: 'root',
})
export class NonContractPurchaseService {
  constructor(
    private http: HttpClient,
    private log: ErrorLoggerService,
  ) {}

  nonContractPurchase(): Observable<NonContractPurchase[]> {
    return this.http
      .post<NonContractPurchase[]>(url, {})
      .pipe(catchError(this.log.handleError(serviceName, 'nonContractPurchase'))) as Observable<
      NonContractPurchase[]
    >;
  }
}
