import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { ProductGroup } from '../core/product-group';

import { ProductGroupService } from './product-group.service';

@Injectable({
  providedIn: 'root',
})
export class ProductGroupResolver {
  constructor(private ser: ProductGroupService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<ProductGroup> {
    const id = route.paramMap.get('id');
    return this.ser.get(id);
  }
}
