import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { ProfitLossResolver } from './profit-loss-resolver.service';
import { ProfitLossComponent } from './profit-loss.component';

const profitLossRoutes: Routes = [
  {
    path: '',
    component: ProfitLossComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Profit & Loss',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(ProfitLossResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(profitLossRoutes)],
  exports: [RouterModule],
  providers: [ProfitLossResolver],
})
export class ProfitLossRoutingModule {}
