import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { Purchases } from './purchases';
import { PurchasesService } from './purchases.service';

@Injectable({
  providedIn: 'root',
})
export class PurchasesResolver {
  constructor(private ser: PurchasesService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Purchases> {
    const startDate = route.queryParamMap.get('startDate') || null;
    const finishDate = route.queryParamMap.get('finishDate') || null;
    return this.ser.list(startDate, finishDate);
  }
}
