import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { RawMaterialCostResolver } from './raw-material-cost-resolver.service';
import { RawMaterialCostComponent } from './raw-material-cost.component';

const rawMaterialCostRoutes: Routes = [
  {
    path: '',
    component: RawMaterialCostComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Raw Material Cost',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(RawMaterialCostResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
  {
    path: ':id',
    component: RawMaterialCostComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Raw Material Cost',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(RawMaterialCostResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(rawMaterialCostRoutes)],
  exports: [RouterModule],
  providers: [RawMaterialCostResolver],
})
export class RawMaterialCostRoutingModule {}
