import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { Voucher } from '../core/voucher';
import { VoucherService } from '../core/voucher.service';

@Injectable({
  providedIn: 'root',
})
export class ReceiptResolver {
  constructor(private ser: VoucherService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<Voucher> {
    const id = route.paramMap.get('id');
    const account = route.queryParamMap.get('a') || null;
    if (id !== null) {
      return this.ser.get(id, 'Receipt');
    }
    if (account !== null) {
      return this.ser.getOfType('Receipt', account);
    }
    return this.ser.getOfType('Receipt');
  }
}
