import { Component, OnInit, ViewChild } from '@angular/core';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { ActivatedRoute } from '@angular/router';

import { RecipeTemplate } from '../recipe-template';

import { RecipeTemplateListDataSource } from './recipe-template-list-datasource';

@Component({
  selector: 'app-recipe-template-list',
  templateUrl: './recipe-template-list.component.html',
  styleUrls: ['./recipe-template-list.component.css'],
})
export class RecipeTemplateListComponent implements OnInit {
  @ViewChild(MatPaginator, { static: true }) paginator?: MatPaginator;
  @ViewChild(MatSort, { static: true }) sort?: MatSort;
  list: RecipeTemplate[] = [];
  dataSource: RecipeTemplateListDataSource = new RecipeTemplateListDataSource(this.list);
  /** Columns displayed in the table. Columns IDs can be added, removed, or reordered. */
  displayedColumns = ['name', 'selected', 'date'];

  constructor(private route: ActivatedRoute) {}

  ngOnInit() {
    this.route.data.subscribe((value) => {
      const data = value as { list: RecipeTemplate[] };

      this.list = data.list;
    });
    this.dataSource = new RecipeTemplateListDataSource(this.list, this.paginator, this.sort);
  }
}
