import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs/internal/Observable';

import { StockMovement } from './stock-movement';
import { StockMovementService } from './stock-movement.service';

@Injectable({
  providedIn: 'root',
})
export class StockMovementResolver {
  constructor(private ser: StockMovementService) {}

  resolve(route: ActivatedRouteSnapshot): Observable<StockMovement> {
    const startDate = route.queryParamMap.get('startDate') || null;
    const finishDate = route.queryParamMap.get('finishDate') || null;
    return this.ser.list(startDate, finishDate);
  }
}
