import { CommonModule } from '@angular/common';
import { NgModule, inject } from '@angular/core';
import { ActivatedRouteSnapshot, RouterModule, RouterStateSnapshot, Routes } from '@angular/router';

import { AuthGuard } from '../auth/auth-guard.service';

import { StockMovementResolver } from './stock-movement-resolver.service';
import { StockMovementComponent } from './stock-movement.component';

const stockMovementRoutes: Routes = [
  {
    path: '',
    component: StockMovementComponent,
    canActivate: [
      (route: ActivatedRouteSnapshot, state: RouterStateSnapshot) =>
        inject(AuthGuard).canActivate(route, state),
    ],
    data: {
      permission: 'Stock Movement',
    },
    resolve: {
      info: (route: ActivatedRouteSnapshot) => inject(StockMovementResolver).resolve(route),
    },
    runGuardsAndResolvers: 'always',
  },
];

@NgModule({
  imports: [CommonModule, RouterModule.forChild(stockMovementRoutes)],
  exports: [RouterModule],
  providers: [StockMovementResolver],
})
export class StockMovementRoutingModule {}
