import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/internal/Observable';
import { catchError } from 'rxjs/operators';

import { ErrorLoggerService } from '../core/error-logger.service';

import { TrialBalance } from './trial-balance';

const url = '/api/trial-balance';
const serviceName = 'TrialBalanceService';

@Injectable({
  providedIn: 'root',
})
export class TrialBalanceService {
  constructor(
    private http: HttpClient,
    private log: ErrorLoggerService,
  ) {}

  list(date: string | null): Observable<TrialBalance> {
    const listUrl = date === null ? url : `${url}/${date}`;
    return this.http
      .get<TrialBalance>(listUrl)
      .pipe(catchError(this.log.handleError(serviceName, 'list'))) as Observable<TrialBalance>;
  }
}
